## re2c 0.16

=== debian/changelog ===
re2c (0.16-1) unstable; urgency=medium

  * New upstream release:
    + Fixes test failures on big endian archs. (LP: #1531563)
  * Rules: ensure failed tests are visible in the buildlog.
  * Drop patch 01, merged upstream.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Fri, 22 Jan 2016 10:26:19 +0000

re2c (0.15.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #747184)
  * New maintainer. (Closes: #808410)
  * Add d/source/format, set to 3.0 (quilt).
  * Control:
    + Set debhelper version (and d/compat) to 9.
    + Add missing ${misc:Depends} dependency to the binary package.
    + Add VCS links.
    + Change upstream homepage to re2c.org.
    + Description: remove needless dot from the end, stop using first
      person.
  * Copyright: update list of upstream authors.
  * Docs: don't install README, not relevant for end users and
    duplicating info already in the packaging.
  * Rules: convert to dh sequencer.
  * Examples: don't install "lessons", removed upstream.
  * Bump standards-version to 3.9.6 (from 3.8.0), no further changes.
  * Add patch 01: fix typos in manpage and usage info.
  * Watch: escape dot in version matching regexp.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 21 Dec 2015 07:55:14 +0000

re2c (0.13.5-1) unstable; urgency=low

  * New upstream release; closes: #486598.
  * Update to Standards-Version: 3.8.0.

 -- Robert S. Edmonds <edmonds@debian.org>  Thu, 17 Jul 2008 16:08:56 -0400

re2c (0.13.3-1) unstable; urgency=low

  * New upstream release; closes: #472003.

 -- Robert S. Edmonds <edmonds@debian.org>  Tue, 01 Apr 2008 16:16:59 -0400

re2c (0.12.1-1) unstable; urgency=low

  * New upstream release, closes: #416697.
  * New maintainer, closes: #320283.

 -- Robert S. Edmonds <edmonds@debian.org>  Sun, 27 May 2007 19:56:53 -0400

re2c (0.9.12-2) unstable; urgency=low

  * QA upload.
  * re.h: Add forward declaration for gcc 4.1.  Thanks to Martin Michlmayr
    for the patch.  Closes:  #356168.

 -- Matej Vela <vela@debian.org>  Fri, 10 Mar 2006 08:20:45 +0100

re2c (0.9.12-1) unstable; urgency=low

  * QA upload.
  * New upstream release.  Closes: #348983.

 -- Matej Vela <vela@debian.org>  Sat, 21 Jan 2006 22:22:46 +0100

re2c (0.9.10-2) unstable; urgency=low

  [ QA Group upload ]
  * debian/changelog: restore 0.9.1-7 changelog entry
  * debian/rules:
    - remove -I. from CFLAGS (redundant)
    - remove INSTALL* cruft (not used)
    - touch build-stamp to prevent running the tests twice
    - use make distclean is buggy, so do the equivalent of it using rm
    - add binary-indep target as it is required by policy
    - re2c.1 already installed by upstream
  * debian/watch:
    - use version=2 for dehs compatability
    - quote .tar.gz

 -- Paul Wise <pabs3@bonedaddy.net>  Tue, 18 Oct 2005 17:41:50 +0800

re2c (0.9.10-1) unstable; urgency=low

  [ QA Group upload ]
  * New upstream release
  * Add Homepage to package description

 -- Paul Wise <pabs3@bonedaddy.net>  Tue, 18 Oct 2005 17:02:17 +0800

re2c (0.9.9-2) unstable; urgency=low

  [ QA Group upload ]
  * Clean the source tree properly
  * Remove prerm/postinst
  * Strip binaries properly
  * Fix examples permissions

 -- Paul Wise <pabs3@bonedaddy.net>  Thu,  1 Sep 2005 13:01:08 +0800

re2c (0.9.9-1) unstable; urgency=low

  [ QA Group upload ]
  * New upstream release (Closes: #300923)
  * Add watch file
  * Update to latest standards version (no changes)
  * Modernise debian/rules
  * Run tests during build
  * Update debian/copyright

 -- Paul Wise <pabs3@bonedaddy.net>  Fri, 19 Aug 2005 15:10:37 +0800

re2c (0.9.1-7) unstable; urgency=low

  * QA Group upload orphaning this package

 -- Andrew Pollock <apollock@debian.org>  Wed,  7 Sep 2005 09:47:06 +1000

re2c (0.9.1-6) unstable; urgency=high

  * The bootstrapping system was broken by the last upload.  This upload
    corrects the bootstrap path, and yacc and re2c paths should work as well.

 -- Daniel Bungert <drb@debian.org>  Thu,  2 Sep 2004 23:55:31 -0400

re2c (0.9.1-5) unstable; urgency=high

  * Apply workaround from  LaMont Jones <lamont@mmjgroup.com> for race
    condition in build scripts. (Closes: #259337, #268673)

 -- Daniel Bungert <drb@debian.org>  Wed,  1 Sep 2004 20:51:21 -0400

re2c (0.9.1-4) unstable; urgency=low

  * Apply workaround from Serge Semashko <ss@vba.com.by> to remove
    some useless compilier warnings (warning: label 'foo' defined but
    not used) in generated code.
  * Now builds with g++-3.3.
  * Build with g++3.3 for c102 transition.  (Closes: #236115)
  * Standards version 3.6.1

 -- Daniel Bungert <drb@debian.org>  Thu, 04 Mar 2004 20:36:19 -0500 

re2c (0.9.1-3) unstable; urgency=low

  * More debian/rules cleaning.
  * Remove bogus build-dep.

 -- Daniel Bungert <drb@debian.org>  Fri, 08 Mar 2002 11:19:19 -0500

re2c (0.9.1-2) unstable; urgency=low

  * Now builds with g++-3.
  * A little debian/rules cleaning.

 -- Daniel Bungert <drb@debian.org>  Sun, 11 Nov 2001 15:17:26 -0500 

re2c (0.9.1-1) unstable; urgency=low

  * Initial Release. (Closes: #113641)

 -- Daniel Bungert <drb@debian.org>  Sun, 16 Sep 2001 01:35:17 -0400
