=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_installexamples:
	dh_installexamples -Xwindows

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_auto_test:
	# ensure failed tests are visible in the buildlog
	$(MAKE) check || /bin/sh -c 'cat test-suite.log; false'
