=== debian/watch ===
version=3
http://sf.net/re2c/re2c-([\d\.]*)\.tar\.gz
