## re2c 1.0.1

=== debian/changelog ===
re2c (1.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Control: mark package multi-arch: foreign. (Closes: #865011)
  * Bump Standards-Version to 4.1.0.0 (from 3.9.8; no further changes).
  * Patches:
    + Remove 01, merged upstream.
    + Update 02 to catch fresh new typos.
  * Compat: bump to 10 (from 9) and set debhelper version accordingly.
  * Rules:
    + simplify dh_auto_test override.
    + exclude all examples from compression.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 22 Aug 2017 15:27:17 +0000

re2c (0.16-2) unstable; urgency=medium

  * Control: switch Vcs-Git url to https.
  * Rules:
    + enable all hardening options.
    + don't run tests when crosscompiling; patch courtesy of Helmut
      Grohne. (Closes: #843217)
    + tweak compression of examples for consistency. (Closes: #849575)
  * Watch: switch to github, upstream only keeps sf.net around as a
    backup.
  * Patches:
    + add 01: fix segvault with null input, backported from upstream
      commit 54711f6. (Closes: #823999)
    + add 02: correct some minor typos in the manpage.
  * Bump Standards-Version to 3.9.8 (from 3.9.6, no further changes).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 10 Jan 2017 10:23:58 +0000
