=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: devel
 Priority: optional
 Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
-Build-Depends: debhelper (>= 9), bison
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 10), bison
+Standards-Version: 4.1.0.0
 Homepage: http://re2c.org
-Vcs-Git: git://github.com/jcfp/debpkg-re2c.git
+Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
 Vcs-Browser: https://github.com/jcfp/debpkg-re2c/
 
 Package: re2c
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: tool for generating fast C-based recognizers
  re2c is a great tool for writing fast and flexible lexers. Unlike
