=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installexamples:
	dh_installexamples -Xwindows

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_auto_test:
	dh_auto_test
	# ensure failed tests are visible in the buildlog
	/bin/sh -c 'cat test-suite.log || true'

override_dh_compress:
	dh_compress -X examples/
