## re2c 1.1.1

=== debian/changelog ===
re2c (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.1 (from 4.1.0; no further changes).
  * Set compat level and debhelper build-dep version to 11.
  * Patches:
    + refresh 02.
    + add 03_backported_fix_upstream_issue_215.
  * Remove trailing whitespaces from d/{changelog,control}.
  * Copyright:
    + convert to machine-readable format.
    + add entries for some of the test files.
  * Tests: add initial autopkgtest, using upstream test suite.
  * Lintian: override license-problem-php-license and
    override_dh_auto_test-does-not-check-DEB_BUILD_OPTIONS: both false
    positives.
  * Rules: remove overrides for dh_installexamples (excluded files no
    longer shipped upstream) and dh_installchangelogs (file is found
    automagically now).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Wed, 03 Oct 2018 08:41:27 +0000
