=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,6 @@
 %:
 	dh $@
 
-override_dh_installexamples:
-	dh_installexamples -Xwindows
-
-override_dh_installchangelogs:
-	dh_installchangelogs CHANGELOG
-
 override_dh_auto_test:
 	dh_auto_test
 	# ensure failed tests are visible in the buildlog
