## re2c 1.2.1

=== debian/changelog ===
re2c (1.2.1-1ubuntu0.1) eoan-security; urgency=medium

  * SECURITY UPDATE: Heap-based buffer overflow
    - debian/patches/CVE-2020-11958.patch: fix calculation
      of the shift offset in src/parse/scanner.cc.
    - CVE-2020-11958

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 21 Apr 2020 11:06:43 -0300

re2c (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Watch: extend extensions for releases beyond just ".tar.gz".
  * Patches:
    + refresh 02 (remove fuzz) and rebase on manpage source files.
    + remove 03 (issue fixed upstream).
  * Copyright: adjust file path for php-releated tests that were moved
    to a subdir.
  * Rules:
    + remove dh_compress override, examples are excluded by default
      with compat 12.
    + override dh_auto_configure: add --enable-docs to generate docs
      during build rather than rely on bootstrapped files.
  * d/docs: remove, sole listed file no longer shipped upstream.
  * Bump compat level to 12 (from 11; no further changes).
  * Bump Standards-Version to 4.4.0 (from 4.2.1; no further changes).
  * Control:
    + use debhelper-compat instead of debian/compat.
    + add build-dep on python3-docutils (needed by --enable-docs).
  * d/clean: add to remove files modified by --enable-docs.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 12 Aug 2019 09:44:08 +0000
