=== debian/control ===
--- 
+++ 
@@ -1,9 +1,13 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
-Build-Depends: debhelper (>= 11), bison
-Standards-Version: 4.2.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Build-Depends:
+ bison,
+ debhelper-compat (= 12),
+ python3-docutils
+Standards-Version: 4.4.0
 Homepage: http://re2c.org
 Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
 Vcs-Browser: https://github.com/jcfp/debpkg-re2c/
