## re2c 1.3

=== debian/changelog ===
re2c (1.3-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Mar 2020 13:29:19 +0100

re2c (1.3-1) unstable; urgency=medium

  [ JCF Ploemen (jcfp) ]
  * New upstream release:
    + makes the build reproducible. (Closes: #934697)
  * Control: switch Vcs fields to salsa.d.o.
  * Patches: remove all, merged upstream.
  * Copyright: account for upstream reshuffling of tests and add entries
    for new tests.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.
  * Bump Standards-Version to 4.4.1 (from 4.4.0; no further changes).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Wed, 08 Jan 2020 10:57:29 +0000
