=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
 Build-Depends:
  bison,
  debhelper-compat (= 12),
  python3-docutils
-Standards-Version: 4.4.0
-Homepage: http://re2c.org
-Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
-Vcs-Browser: https://github.com/jcfp/debpkg-re2c/
+Standards-Version: 4.4.1
+Homepage: https://re2c.org
+Vcs-Git: https://salsa.debian.org/jcfp-guest/re2c.git
+Vcs-Browser: https://salsa.debian.org/jcfp-guest/re2c
 
 Package: re2c
 Architecture: any
