=== debian/tests/control ===
Tests: upstream-runtests
Depends: @, build-essential, debhelper, dh-autoreconf
Restrictions: rw-build-tree
