=== debian/changelog ===
re2c (2.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Patches: remove 01 (fix released upstream), refresh 02.
  * Copyright:
    + account for renamed test files.
    + update current upstream maintainer info.
  * Control: refresh description, mention newly added support for Go.
  * Rules: don't install the __run_all scripts with the examples.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 24 Aug 2020 09:05:07 +0000

re2c (1.3-2) unstable; urgency=high

  [ JCF Ploemen (jcfp) ]
  * Control: add build-dep on python3-pygments, for use by rst2man.
  * Patches:
    + add 01, backport of the upstream fix for a heap-based buffer
      overflow in Scanner::fill in parse/scanner.cc.
      (CVE-2020-11958; closes: #963158)
    + add 02, fix for a manpage spelling error.
  * Rules: switch dh_auto_test override to execute_after.
  * Lintian: remove override for override_dh_auto_test-does-not-
    check-DEB_BUILD_OPTIONS, no longer needed.
  * Bump compat level to 13 (from 12; no further changes).

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.
  * Update standards version to 4.5.0, no changes needed.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 23 Jun 2020 14:18:11 +0000
