=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,13 @@
 %:
 	dh $@
 
-override_dh_auto_test:
-	dh_auto_test
+override_dh_auto_configure:
+	dh_auto_configure -- --enable-docs
+
+execute_after_dh_installexamples:
+	rm -f debian/re2c/usr/share/doc/re2c/examples/c/__run_all.sh
+	rm -f debian/re2c/usr/share/doc/re2c/examples/go/__run_all.sh
+
+execute_after_dh_auto_test:
 	# ensure failed tests are visible in the buildlog
 	/bin/sh -c 'cat test-suite.log || true'
-
-override_dh_compress:
-	dh_compress -X examples/
