## re2c 2.2

=== debian/changelog ===
re2c (2.2-1deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:17:45 +0800

re2c (2.2-1) unstable; urgency=medium

  * New upstream release.
  * Change maintainer to my debian.org email address.
  * Bump Standards-Version to 4.6.0 (from 4.5.1; no further changes).
  * Rules: add override for dh_auto_test to ensure Python
    multiprocessing.Pool() is supported, and otherwise skip the
    testsuite.
  * Tests: upstream switched testsuite to Python3, adjust the
    autopkgtest accordingly.
  * Control: build-depend on python3 for the upstream testsuite.

 -- Jeroen Ploemen <jcfp@debian.org>  Thu, 19 Aug 2021 10:17:21 +0000

re2c (2.1.1-1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.1 (from 4.5.0; no further changes).
  * Watch: bump version to 4.
  * Control: add Rules-Requires-Root: no.
  * Patches: expand 02 to cover fresh new typos.

 -- Jeroen Ploemen <jcfp@debian.org>  Wed, 07 Jul 2021 09:20:41 +0000
