=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,12 @@
 	rm -f debian/re2c/usr/share/doc/re2c/examples/c/__run_all.sh
 	rm -f debian/re2c/usr/share/doc/re2c/examples/go/__run_all.sh
 
+override_dh_auto_test:
+	# testsuite requires Python multiprocessing.Pool()
+	/bin/sh -c 'python3 -c "from multiprocessing import Pool; pool = Pool(); pool.close()" \
+		&& dh_auto_test \
+		|| echo "Support for multiprocessing.Pool() missing, skipping testsuite"'
+
 execute_after_dh_auto_test:
 	# ensure failed tests are visible in the buildlog
 	/bin/sh -c 'cat test-suite.log || true'
