## re2c 3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,64 +1,60 @@
 cmake_minimum_required(VERSION 3.12)
-project(re2c VERSION 2.0.3 HOMEPAGE_URL "https://re2c.org/")
+project(re2c VERSION 3.0 HOMEPAGE_URL "https://re2c.org/")
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
 include(Re2cAutotoolsHelpers)
 include(Re2cBootstrapLexer)
 include(Re2cBootstrapParser)
+include(Re2cBuildType)
 include(Re2cGenDocs)
-include(Re2cTryCXXFlag)
+include(Re2cCompilerFlags)
 
 ac_subst(PACKAGE_VERSION "${PROJECT_VERSION}")
 
 option(RE2C_REBUILD_LEXERS "Regenerate lexers" OFF)
 if(RE2C_REBUILD_LEXERS AND NOT RE2C_FOR_BUILD)
-    message(FATAL_ERROR "need RE2C_FOR_BUILD for RE2C_REBUILD_LEXERS")
+    message(FATAL_ERROR "option RE2C_FOR_BUILD is required for RE2C_REBUILD_LEXERS")
 endif()
 
 option(RE2C_REBUILD_DOCS "Regenerate manpage" OFF)
 if(RE2C_REBUILD_DOCS)
     find_program(RST2MAN NAMES rst2man rst2man.py)
     if(NOT RST2MAN)
-        message(FATAL_ERROR "need rst2man or rst2man.py for RE2C_REBUILD_DOCS")
+        message(FATAL_ERROR "rst2man (or rst2man.py) program is required for RE2C_REBUILD_DOCS")
     endif()
+
+    # Windows does not have a native 'man' and 'sed' commands.
+    # Therefore, we are looking for the Cygwin versions of 'man' and 'sed'.
+    if (WIN32)
+        find_program(MAN_EXECUTABLE man)
+        if(NOT MAN_EXECUTABLE)
+            message(FATAL_ERROR "man program is required for RE2C_REBUILD_DOCS")
+        endif()
+
+        find_program(SED_EXECUTABLE sed)
+        if(NOT SED_EXECUTABLE)
+            message(FATAL_ERROR "sed program is required for RE2C_REBUILD_DOCS")
+        endif()
+    endif()
 endif()
 
 option(RE2C_BUILD_LIBS "Build libraries" OFF)
 
 option(RE2C_BUILD_RE2GO "Build re2go executable (an alias for `re2c --lang go`)" ON)
+option(RE2C_BUILD_RE2RUST "Build re2rust executable (an alias for `re2c --lang rust`)" ON)
+
+option(RE2C_BUILD_BENCHMARKS "Build benchmarks" OFF)
+option(RE2C_REGEN_BENCHMARKS "Regenerate C code for benchmarks" OFF)
 
 # checks for programs
 find_package(BISON)
+find_package(Python3 COMPONENTS Interpreter)
 
 # checks for C++ compiler flags
 set(CMAKE_CXX_STANDARD 98)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON) # make sure object libraries work with shared libraries
-if(NOT CMAKE_BUILD_TYPE)
-    try_cxxflag("-O2")
-endif()
-try_cxxflag("-W")
-try_cxxflag("-Wall")
-try_cxxflag("-Wextra")
-try_cxxflag("-Weffc++")
-try_cxxflag("-pedantic")
-try_cxxflag("-Wformat=2")
-try_cxxflag("-Wredundant-decls")
-try_cxxflag("-Wsuggest-attribute=format")
-try_cxxflag("-Wconversion")
-try_cxxflag("-Wsign-conversion")
-try_cxxflag("-Werror=return-type")
-try_cxxflag("-Weverything"
-    "-Wno-unknown-warning-option" # CLANG eats some GCC options only to warn they are unknown
-    "-Wno-reserved-id-macro" # to allow header guards of the form '_RE2C_PATH_TO_HEADER_BASENAME_'
-    "-Wno-padded"
-    "-Wno-old-style-cast" # RE2C-generated lexer has lots of C-syle casts because of 're2c:yych:conversion = 1;'
-    "-Wno-nested-anon-types"
-    "-Wno-global-constructors" # initialization of global constants with std::numeric_limits<...> (mostly for size_t)
-    "-Wno-shadow-field-in-constructor" # using same names in ctor seems more like a feature
-    "-Wno-undefined-func-template" # explicit specialization to reduce build dependencies
-)
-try_cxxflag("-fdiagnostics-color=always")
 
 # use system stdint.h if present, otherwise fallback to src/c99_stdint.h
 ac_check_headers("stdint.h")
@@ -101,11 +97,14 @@
 )
 
 set(top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")
+set(top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
+set(PYTHON "${Python3_EXECUTABLE}")
+
 configure_file(doc/manpage.rst.in doc/manpage.rst @ONLY)
 configure_file(doc/help.rst.in doc/help.rst @ONLY)
 
-configure_file(run_tests.sh.in run_tests.sh @ONLY)
-set(RE2C_RUN_TESTS "${CMAKE_CURRENT_BINARY_DIR}/run_tests.sh")
+configure_file(run_tests.py.in run_tests.py @ONLY)
+set(RE2C_RUN_TESTS "${CMAKE_CURRENT_BINARY_DIR}/run_tests.py")
 if(CMAKE_HOST_UNIX)
     execute_process(COMMAND chmod +x "${RE2C_RUN_TESTS}")
 endif()
@@ -147,12 +146,13 @@
     src/codegen/gen_program.cc
     src/codegen/gen_state.cc
     src/codegen/helpers.cc
+    src/codegen/remove_empty.cc
     src/codegen/render.cc
     src/options/opt.cc
+    src/options/symtab.cc
     src/nfa/estimate_size.cc
     src/nfa/re_to_nfa.cc
     src/adfa/adfa.cc
-    src/adfa/prepare.cc
     src/debug/dump_adfa.cc
     src/debug/dump_cfg.cc
     src/debug/dump_dfa.cc
@@ -192,6 +192,7 @@
     src/regexp/default_tags.cc
     src/regexp/fixed_tags.cc
     src/regexp/nullable.cc
+    src/regexp/re.cc
     src/regexp/rule.cc
     src/regexp/split_charset.cc
     src/regexp/tag.cc
@@ -203,11 +204,10 @@
     src/skeleton/skeleton.cc
     src/parse/ast.cc
     src/parse/input.cc
-    src/parse/normalize.cc
+    src/parse/parse.cc
     src/parse/scanner.cc
     src/parse/unescape.cc
-    src/parse/validate.cc
-    src/util/get_dir.cc
+    src/util/file_utils.cc
     src/util/s_to_n32_unsafe.cc
     src/util/temp_file.cc
     src/util/range.cc
@@ -225,6 +225,12 @@
     target_compile_definitions(re2go PUBLIC "RE2C_LANG=LANG_GO")
 endif()
 
+# re2rust
+if (RE2C_BUILD_RE2RUST)
+    add_executable(re2rust ${re2c_sources})
+    target_compile_definitions(re2rust PUBLIC "RE2C_LANG=LANG_RUST")
+endif()
+
 re2c_bootstrap_lexer("src/parse/lex.re" "src/parse/lex.cc" "src/parse/lex.h")
 re2c_bootstrap_lexer("src/parse/lex_conf.re" "src/parse/lex_conf.cc")
 re2c_bootstrap_lexer("src/options/parse_opts.re" "src/options/parse_opts.cc")
@@ -234,8 +240,8 @@
 # docs
 set(re2c_docs_sources
     "${re2c_manpage_source}"
-    "doc/manual/api/api.rst_"
     "doc/manual/api/interface.rst_"
+    "doc/manual/conditions/blocks.rst_"
     "doc/manual/conditions/conditions.rst_"
     "doc/manual/configurations/configurations.rst_"
     "doc/manual/directives/directives.rst_"
@@ -260,13 +266,24 @@
     "doc/manual/state/state.rst_"
     "doc/manual/submatch/submatch_example_mtags.rst_"
     "doc/manual/submatch/submatch_example_posix.rst_"
+    "doc/manual/submatch/submatch_example_stags_fill.rst_"
     "doc/manual/submatch/submatch_example_stags.rst_"
     "doc/manual/submatch/submatch.rst_"
+    "doc/manual/synopsis.rst_"
+    "doc/manual/syntax/api1.rst_"
+    "doc/manual/syntax/api2_c.rst_"
+    "doc/manual/syntax/api2_go.rst_"
+    "doc/manual/syntax/api2_rust.rst_"
+    "doc/manual/syntax/api3.rst_"
+    "doc/manual/syntax/intro.rst_"
     "doc/manual/syntax/syntax.rst_"
     "doc/manual/warnings/warnings_general.rst_"
     "doc/manual/warnings/warnings_list.rst_"
     "examples/c/01_basic.re"
+    "examples/c/01_basic.c"
+    "examples/c/conditions/parse_u32_blocks.re"
     "examples/c/conditions/parse_u32_conditions.re"
+    "examples/c/encodings/unicode_identifier.re"
     "examples/c/eof/01_sentinel.re"
     "examples/c/eof/02_bounds_checking.re"
     "examples/c/eof/03_eof_rule.re"
@@ -274,16 +291,21 @@
     "examples/c/fill/01_fill.re"
     "examples/c/fill/02_fill.re"
     "examples/c/headers/header.re"
-    "examples/c/headers/src/lexer/lexer.h"
+    "examples/c/headers/lexer/state.h"
     "examples/c/includes/include.re"
     "examples/c/includes/definitions.h"
     "examples/c/reuse/reuse.re"
+    "examples/c/reuse/usedir.re"
     "examples/c/state/push.re"
+    "examples/c/submatch/01_stags_fill.re"
     "examples/c/submatch/01_stags.re"
     "examples/c/submatch/02_mtags.re"
     "examples/c/submatch/03_posix.re"
     "examples/go/01_basic.re"
+    "examples/go/01_basic.go"
+    "examples/go/conditions/parse_u32_blocks.re"
     "examples/go/conditions/parse_u32_conditions.re"
+    "examples/go/encodings/unicode_identifier.re"
     "examples/go/eof/01_sentinel.re"
     "examples/go/eof/02_bounds_checking.re"
     "examples/go/eof/03_eof_rule.re"
@@ -291,48 +313,32 @@
     "examples/go/fill/01_fill.re"
     "examples/go/fill/02_fill.re"
     "examples/go/headers/header.re"
-    "examples/go/headers/src/lexer/lexer.go"
+    "examples/go/headers/lexer/state.go"
     "examples/go/includes/include.re"
     "examples/go/includes/definitions.go"
     "examples/go/reuse/reuse.re"
+    "examples/go/reuse/usedir.re"
     "examples/go/state/push.re"
+    "examples/go/submatch/01_stags_fill.re"
     "examples/go/submatch/01_stags.re"
     "examples/go/submatch/02_mtags.re"
     "examples/go/submatch/03_posix.re"
-)
-re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_c}"  "${re2c_manpage_bootstrap_c}"  "c")
-re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_go}" "${re2c_manpage_bootstrap_go}" "go")
-re2c_gen_help("${re2c_help_source}" "${re2c_help}" "${re2c_help_bootstrap}")
-add_custom_target(docs DEPENDS "${re2c_docs}")
-
-# install and test targets are enabled only if re2c is the root project
-if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
-    # install
-    if(UNIX)
-        install(TARGETS re2c RUNTIME DESTINATION bin)
-        install(FILES "${re2c_manpage_c}" DESTINATION "share/man/man1")
-        if(RE2C_BUILD_RE2GO)
-            install(TARGETS re2go RUNTIME DESTINATION bin)
-            install(FILES "${re2c_manpage_go}" DESTINATION "share/man/man1")
-        endif()
-        install(FILES include/unicode_categories.re DESTINATION "${RE2C_STDLIB_DIR}")
-    endif()
-
-    # rebuild all re2c sources using newly built re2c
-    add_custom_target(bootstrap
-        COMMAND cmake -E remove_directory "src"
-        COMMAND cmake -E remove_directory "doc"
-        COMMAND cmake --build "${CMAKE_CURRENT_BINARY_DIR}"
-    )
-
-    # tests
-    add_custom_target(tests
-        DEPENDS "${RE2C_RUN_TESTS}"
-        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-        COMMAND "${RE2C_RUN_TESTS}"
-    )
-    add_dependencies(tests re2c)
-    add_custom_target(vtests
-        DEPENDS "${RE2C_RUN_TESTS}"
-        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-        COMMAND "${RE2C_RUN_TESTS}" --valgrind
+    "examples/rust/01_basic.re"
+    "examples/rust/01_basic.rs"
+    "examples/rust/conditions/parse_u32_blocks.re"
+    "examples/rust/conditions/parse_u32_conditions.re"
+    "examples/rust/encodings/unicode_identifier.re"
+    "examples/rust/eof/01_sentinel.re"
+    "examples/rust/eof/02_bounds_checking.re"
+    "examples/rust/eof/03_eof_rule.re"
+    "examples/rust/eof/05_generic_api_eof_rule.re"
+    "examples/rust/fill/01_fill.re"
+    "examples/rust/fill/02_fill.re"
+    "examples/rust/headers/header.re"
+    "examples/rust/headers/lexer/state.rs"
+    "examples/rust/includes/include.re"
+    "examples/rust/includes/definitions.rs"
+    "examples/rust/reuse/reuse.re"
+    "examples/rust/reuse/usedir.re"
+    "examples/rust/state/push.re"
+    "examples/rust/submatch/01_stags_fill.re"
