=== debian/changelog ===
re2c (3.0-1) unstable; urgency=medium

  * New upstream version 3.0
  * Tests: also symlink re2go, re2rust in upstream-runtests.
  * Patches: refresh 02 (mostly merged upstream).
  * Rules: also remove __run_all script from rust examples.
  * Lintian: add override to ignore long lines in test data.
  * Control: update short description to mention Rust support.

 -- Jeroen Ploemen <jcfp@debian.org>  Thu, 03 Feb 2022 12:01:46 +0000
