=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Maintainer: Jeroen Ploemen <jcfp@debian.org>
 Build-Depends:
  bison,
  debhelper-compat (= 13),
+ python3 <!nocheck>,
  python3-docutils,
  python3-pygments
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://re2c.org
 Vcs-Git: https://salsa.debian.org/jcfp/re2c.git
 Vcs-Browser: https://salsa.debian.org/jcfp/re2c
+Rules-Requires-Root: no
 
 Package: re2c
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: lexer generator for C, C++ and Go
+Description: lexer generator for C, C++, Go and Rust
  re2c's main goal is generating fast lexers: at least as fast as
  their reasonably optimized hand-coded counterparts. Instead of using
  a traditional table-driven approach, re2c encodes the generated
