=== debian/tests/control ===
Tests: upstream-runtests
Depends: @, build-essential, debhelper, dh-autoreconf, python3
Restrictions: rw-build-tree
